#! /bin/bash
# kate: space-indent on; indent-width 2; replace-tabs on;
langfile=`tempfile`;
KDEDIR=`tempfile`;
logfile=`tempfile`;
if test -f $KDEDIR; then rm -f $KDEDIR; mkdir $KDEDIR; fi ;
export KDEDIR;
lists=`ls -1 all_files_*` ;
: > $logfile ;
languages=`cat subdirs`; 
for listfile in $lists; do 
  mod=`echo $listfile | sed -e "s,all_files_,,"` ;
  : > $langfile ;
  for lang in $languages; do 
    file=`find $lang/messages -name "desktop_$mod.po"` ;
    if test -z "$file"; then 
      continue ;
    fi ;
    charsetline=`egrep "^\"Content-Type: .*/.*;? charset=.*\n\"" $file`;
    if test -z "$charsetline"; then 
      echo "file $file does not declare charset!"
      fgrep -i "Content-Type" $file
      echo "--"
      continue
    else
      charset=`echo $charsetline | sed -e "s#^.*charset=\(.*\)..\"#\1#"`;
      if test ! "$charset" = "utf-8" -a ! "$charset" = "UTF-8"; then
        echo "File $file has unsupported charset: $charset"
        continue
      fi
    fi
    mkdir -p $KDEDIR/share/locale/$lang/LC_MESSAGES; 
    if ! msgfmt $file -o $KDEDIR/share/locale/$lang/LC_MESSAGES/apply.mo; then 
            echo "File $file could not be processed by msgfmt!"; 
            continue; 
    fi; 
    echo $lang >> $langfile ;
  done; 
  filelanguages=`sort -u $langfile` ;
  list=`cat $listfile` ; 
  for i in $list; do 
    if ./apply $i $filelanguages >> $logfile 2>&1; then
      if cmp -s i $i.new; then
        rm $i.new
      else
        mv -f $i.new $i
      fi
    fi
  done
done
sort $logfile ;
rm -f $logfile $langfile ;
rm -rf $KDEDIR
